/*
Read and overwrite CSV file.
Send data to Arduino with serial communication
*/

import processing.serial.*;

Serial myPort;

int rectX, rectY;      // Position of square button
int rectWidth = 50;     // width of rect
int rectHeight = 30;
color rectColor;
color rectHighlight;
boolean rectOver = false;
Table inventory;
int i = 0;
int j = 0;

//char letter;
String words = "";

void setup(){
  size(1000, 750);
  background(90,84,75); // Set background color
  rectColor = color(243,243,242); //set text box color
  rectHighlight = color(139,150,141); //set text box color when mousepressed
  rectX = (width/3)*2;
  rectY = height/6-rectHeight/2;
  textSize(20);
  text("send", rectX, rectY+rectHeight*2);
  inventory = loadTable("inventory.csv", "header");
  myPort = new Serial(this,"COM12",9600);//open serial port
  myPort.write(0);
}

void draw() {
  update(mouseX, mouseY);
  if (rectOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  stroke(255);
  rect(rectX, rectY, rectWidth, rectHeight);//position and size of send button
  rect(width/4, rectY, 300, 30); //position and size of textbox
  // Draw the letter to the center of the screen
  fill(255);
  textSize(22);
  fill(90,84,75);
  text(words, width/4+5,rectY, 200, 30);
  textSize(18);
  fill(243,243,242);
  //arrange boxNumber,partName,InventryNumber
  for (int i = 0; i < 24; i++){
  for (int j =0; j < 3; j++){
  text(inventory.getString(i,j)+"\n",50+200*(i%4),200+(i /4)*80+20*j,200,100);    
}
}
}


void update(int x, int y) {
  if ( overRect(rectX, rectY, rectWidth, rectHeight) ) {
    rectOver = true;
  } else {
    rectOver = false;
  }
}

//Operation when send button is pushed
void mousePressed() {
  if (rectOver) {
    for ( i = 0; i < inventory.getRowCount(); i++){
      int boxNum = inventory.getInt(i, "boxNumber");
      String partName = inventory.getString(i, "partName");
      int inbentoryNum = inventory.getInt(i, "inbentoryNumber");
      //println(boxNumb);
      //println(partName);
      //println(inbentoryNumb);
      
      if (partName.equals(words)){      //if input words correspond to the part name
        //myPort.write(boxNum);        //send boxnumber to arduino from serialport
        inbentoryNum -= 1;              //reduce inventory number
        inventory.setInt(i,"inbentoryNumber",inbentoryNum);  //display recent inventory number
    //println(words);
        words ="";                        //empty the text box
        background(90,84,75);
        saveTable(inventory,"inventory.csv"); //overwrite csv file
    }
    }
  }
  }

boolean overRect(int x, int y, int width, int height)  {
  if (mouseX >= x && mouseX <= x+width && 
      mouseY >= y && mouseY <= y+height) {
    return true;
  } else {
    return false;
  }
}

void keyTyped() {
  // The variable "key" always contains the value 
  // of the most recent key pressed.
//  if ((key >= 'A' && key <= 'z') || key == ' ') {
    //letter = key;
    words = words + key;
//  }
}